// brd_test.cpp : Defines the entry point for the console application.
//
#include <iostream>
#include <tchar.h>

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <time.h>

// TODO: reference additional headers your program requires here
#include "brd.h"
#include "icr.h"
//#include "ctrl.h"
//#include "ctrltest.h"
//#include "ctrlstrm.h"
//#include "ctrladc.h"
//#include "ctrldspnode.h"
//#include "ctrlsdram.h"

TCHAR iniFileName[] = "\\sdram_test.ini";
TCHAR sPldName[MAX_PATH];
int TestMode;
int TestOn;
int SaveToFile;
//__int64 ActiveZoneSize;
ULONG ActiveZoneSize;
U32 all_error_num;
U32 error_num;
unsigned Seed;
ULONG MemoryAddress;
int NumCycles;
int iCycle = 0;
int MemRead;
ULONG AdcDrqFlag;
ULONG TstDrqFlag;
int PldLoadForce;

void SetTestBuffer(PULONG pBuf, ULONG sizeBuf, ULONG offset);
void CompTestBuffer(PULONG pBuf0, PULONG pBuf1, ULONG sizeBuf, ULONG offset);

void ReadIniFile(char* iniFileName)
{
	TCHAR iniFilePath[MAX_PATH];
	GetCurrentDirectory(sizeof(iniFilePath)/sizeof(TCHAR), iniFilePath);
	_tcscat_s(iniFilePath, iniFileName);
	TCHAR Buffer[128];
	
	GetPrivateProfileString("Option", "PldFileName", "ambpcx_v10_admdio32_sdram_1500.hex", sPldName, sizeof(sPldName), iniFilePath);

	GetPrivateProfileString("Option", "PldLoadForce", "1", Buffer, sizeof(Buffer), iniFilePath);
	PldLoadForce = atoi(Buffer);

	GetPrivateProfileString("Option", "MemorySizeInKBytes", "1000", Buffer, sizeof(Buffer), iniFilePath); // in MBytes
//	ActiveZoneSize = _atoi64(Buffer) * 1024;
	ActiveZoneSize = atoi(Buffer) * 1024;

	GetPrivateProfileString("Option", "MemoryAddressIn32BitWordsHex", "0", Buffer, sizeof(Buffer), iniFilePath); // in 32-bit words (hex)
	char* endptr;
	MemoryAddress = strtoul(Buffer, &endptr, 16);

	GetPrivateProfileString("Option", "TestMode", "0", Buffer, sizeof(Buffer), iniFilePath);
	TestMode = atoi(Buffer);

	GetPrivateProfileString("Option", "TestOn", "1", Buffer, sizeof(Buffer), iniFilePath);
	TestOn = atoi(Buffer);

	GetPrivateProfileString("Option", "SaveToFile", "0", Buffer, sizeof(Buffer), iniFilePath);
	SaveToFile = atoi(Buffer);

	GetPrivateProfileString("Option", "TstDrqFlag", "0", Buffer, sizeof(Buffer), iniFilePath);
	TstDrqFlag = atoi(Buffer);

	GetPrivateProfileString("Option", "AdcDrqFlag", "0", Buffer, sizeof(Buffer), iniFilePath);
	AdcDrqFlag = atoi(Buffer);

	GetPrivateProfileString("Option", "NumCycles", "1", Buffer, sizeof(Buffer), iniFilePath);
	NumCycles = atoi(Buffer);
	if(!NumCycles)
		NumCycles = 1;

	GetPrivateProfileString("Option", "MemRead", "1", Buffer, sizeof(Buffer), iniFilePath);
	MemRead = atoi(Buffer);
	if(!MemRead)
		MemRead = 1;
//	GetPrivateProfileString("Option", "BusMasterEnable", "1", Buffer, sizeof(Buffer), iniFilePath);
//	BusMasterMode = atoi(Buffer);

}

int _tmain(int argc, _TCHAR* argv[])
{
	S32		status;

	if(argc > 1)
	{
		sprintf_s(iniFileName, "\\%s", argv[1]);
	}
	ReadIniFile(iniFileName);

	BRD_displayMode(BRDdm_VISIBLE | BRDdm_CONSOLE);
	
	S32	DevNum;
//	status = BRD_initEx(BRDinit_FILE | BRDinit_AUTOINIT, "brd__.ini", NULL, &DevNum);
	status = BRD_init("brd.ini", &DevNum);
//	BRD_Error* pErrInfo = NULL;
//	status = BRD_error(&pErrInfo);
	BRD_LidList lidList;
	lidList.item = 10;
	lidList.pLID = new U32[10];
	status = BRD_shell(BRDshl_LID_LIST, &lidList);
//	status = BRD_error(&pErrInfo);

	BRD_Info	info;
	info.size = sizeof(info);
	BRD_Handle handle[10];

	for(ULONG i = 0; i < lidList.itemReal; i++)
	{
		BRD_getInfo( lidList.pLID[i], &info );
		printf("Board: %s, DevID = 0x%x, RevID = 0x%x, Bus = %d, Dev = %d, Slot = %d.\n", 
			info.name, info.boardType >> 16, info.boardType & 0xff, info.bus, info.dev, info.slot);
		U32 open_mode;
		handle[i] = BRD_open(lidList.pLID[i], BRDopen_EXCLUSIVE, &open_mode);
		if(handle[i] > 0 && BRDopen_EXCLUSIVE == open_mode)
		{
			BRD_PuList PuList[5];
			U32 ItemReal;
			status = BRD_puList(handle[i], PuList, 5, &ItemReal);
			if(ItemReal <= 5)
			{
				for(U32 j = 0; j < ItemReal; j++)
				{
					printf("PuList_%d: %s, Id = %d, Code = %x, Attr = %x.\n",
									j, PuList[j].puDescription, PuList[j].puId, PuList[j].puCode, PuList[j].puAttr);
					if(PuList[j].puCode == PLD_CFG_TAG && PuList[j].puId == 0x100)
					{
						U32	PldState;
						status = BRD_puState(handle[i], PuList[j].puId, &PldState);
						printf("BRD_puState: ADM PLD State = %d\n", PldState);
						if(PldLoadForce || !PldState)
						{
							TCHAR msg[255];
							sprintf_s(msg, "PLD file name: %s\n", sPldName);
							printf(msg);
							printf("BRD_puLoad: loading...\r");
							LARGE_INTEGER Frequency, StartPerformCount, StopPerformCount;
							int bHighRes = QueryPerformanceFrequency (&Frequency);
							QueryPerformanceCounter (&StartPerformCount);
							status = BRD_puLoad(handle[i], PuList[j].puId, sPldName, &PldState);
							QueryPerformanceCounter (&StopPerformCount);
							double msTime = (double)(StopPerformCount.QuadPart - StartPerformCount.QuadPart) / (double)Frequency.QuadPart * 1.E3;
							if(BRD_errcmp(status, BRDerr_OK))
								printf("BRD_puLoad: load is OK. Loading time is %.2f ms\n", msTime);
							else
								printf("BRD_puLoad: error loading. Loading time is %.2f ms\n", msTime);
						}
					}
				}
			}
			BRD_getInfo( lidList.pLID[i], &info );
			printf("Onboard SDRAM address: 0x%X.\n", info.base[0]);

			if(!info.base[0])
			{
				printf("ERROR - NOT a memory !!!\n");
				break;
			}

//			printf("Press any key for continue program...\n");
//			_getch();

			PULONG pBuf = (PULONG)info.base[0];
//			ULONG buf_mem[128];
			int kkk = 0;
			for(kkk = 0; kkk < 128; kkk++)
				pBuf[kkk] = kkk;
		//	while(1)
		//	{
		////		RegParam.reg = MAINnr_SIG;
		////		Status = RegCtrl(DEVScmd_REGREADIND, &RegParam);
		//		pBuf[0] = kkk++;
		//		Sleep(100);
		//	}
/*			while(1)
			{
				for(kkk = 0; kkk < 128; kkk++)
					buf_mem[kkk] = pBuf[kkk];
//				printf("0x%x, 0x%x, 0x%x, 0x%x, 0x%x, 0x%x, 0x%x, 0x%x\n", 
//					buf_mem[0], buf_mem[1], buf_mem[2], buf_mem[3], buf_mem[4], buf_mem[5], buf_mem[6], buf_mem[7]);
				printf("0x%.8x, 0x%.8x, 0x%.8x, 0x%.8x\n", 
					buf_mem[0], buf_mem[1], buf_mem[2], buf_mem[3]);
//				printf("0x%x, 0x%x, 0x%x, 0x%x, 0x%x, 0x%x, 0x%x, 0x%x\n", 
//					pBuf[0], pBuf[1], pBuf[2], pBuf[3], pBuf[4], pBuf[5], pBuf[6], pBuf[7]);
				printf("0x%.8x, 0x%.8x, 0x%.8x, 0x%.8x\n\n", 
					pBuf[0], pBuf[1], pBuf[2], pBuf[3]);
				Sleep(100);
			}
*/
			ULONG bufSize = 1024 * 1024 * 64; // 64 Mbyte
//			ULONG bufSize = ActiveZoneSize;
			PULONG pMemBuf = (PULONG)VirtualAlloc(NULL, bufSize, MEM_COMMIT, PAGE_READWRITE);

			switch(TestMode)
			{
			case 0: // 
				printf("Counter test\n");
				break;
			case 1: // 
				printf("Running 0 test\n");
				break;
			case 2: // 
				printf("Running 1 test\n");
				break;
			case 3: // 
				printf("Random test\n");
				Seed = (unsigned)time(NULL);
				break;
			}

//			printf("Setting of onboard SDRAM...\n");
			printf("Writing onboard SDRAM...\n");
			SetTestBuffer(pBuf, ActiveZoneSize, MemoryAddress);
			printf("Writing on PC RAM...\n");
			SetTestBuffer(pMemBuf, ActiveZoneSize, MemoryAddress);
			CompTestBuffer(pMemBuf, pBuf, ActiveZoneSize, MemoryAddress);

			VirtualFree(pMemBuf, 0, MEM_RELEASE);

			status = BRD_close(handle[i]);
			printf("BRD_close: OK\n");
		}
	}
	status = BRD_cleanup();
	printf("BRD_cleanup: OK\n");
	printf("Press any key for leaving program...\n");
	_getch();
	return 0;
}

void DisplayError(S32 status, TCHAR* cmd_str)
{
	S32	real_status = BRD_errext(status);
	TCHAR msg[255];
	switch(real_status)
	{
	case BRDerr_OK:
		sprintf_s(msg, "%s: BRDerr_OK\n", cmd_str);
		break;
	case BRDerr_BAD_MODE:
		sprintf_s(msg, "%s: BRDerr_BAD_MODE\n", cmd_str);
		break;
	case BRDerr_INSUFFICIENT_SERVICES:
		sprintf_s(msg, "%s: BRDerr_INSUFFICIENT_SERVICES\n", cmd_str);
		break;
	default:
		sprintf_s(msg, "%s: Unknown error\n", cmd_str);
		break;
	}
	printf(msg);
}

//   
void SetTestBuffer(PULONG pBuf, ULONG sizeBuf, ULONG offset)
{
	LARGE_INTEGER Frequency, StartPerformCount, StopPerformCount;
	int bHighRes = QueryPerformanceFrequency (&Frequency);
	QueryPerformanceCounter (&StartPerformCount);
	switch(TestMode)
	{
	case 0: // 
	{
//		printf("Counter test\n");
		ULONG cnt = sizeBuf / sizeof(ULONG) + offset;
		for(ULONG i = offset; i < cnt; i++)
		{
			if(!(i % 1000))
				printf("address: %08X\r", i);
			pBuf[i] = i;
		}
	}
		break;
	case 1: // 
	{
//		printf("Running 0 test\n");
		__int64 buf_tst;
		ULONG cnt = sizeBuf / sizeof(__int64) / 64;
		ULONG k = 0;
		offset /= 128;
		cnt += offset;
		for(ULONG i = offset; i < cnt; i++)
		{
			if(!(i % 10))
				printf("address: %08X\r", i * 128);
			__int64 mask = 0xfffffffffffffffe;
			for(ULONG j = 0; j < 64; j++)
			{
				buf_tst = mask;
				pBuf[k++] = (ULONG)buf_tst;
				pBuf[k++] = (ULONG)(buf_tst >> 32);
				mask = (mask << 1) + 1;
			}
		}
	}
		break;
	case 2: // 
	{
//		printf("Running 1 test\n");
		__int64 buf_tst;
		ULONG cnt = sizeBuf / sizeof(__int64) / 64;
		ULONG k = 0;
		offset /= 128;
		cnt += offset;
		for(ULONG i = offset; i < cnt; i++)
		{
			if(!(i % 10))
				printf("address: %08X\r", i * 128);
			__int64 mask = 1;
			for(ULONG j = 0; j < 64; j++)
			{
				buf_tst = mask;
				pBuf[k++] = (ULONG)buf_tst;
				pBuf[k++] = (ULONG)(buf_tst >> 32);
				mask = (mask << 1) + 1;
			}
		}
	}
		break;
	case 3: // 
	{
//		printf("Random test\n");
		//        ,    
		srand(Seed);
		ULONG cnt = sizeBuf / sizeof(ULONG) + offset;
		UCHAR buf_tst[4];
		for(ULONG i = offset; i < cnt; i++)
		{
			if(!(i % 1000))
				printf("address: %08X\r", i);
			buf_tst[0] = (UCHAR)rand();
			buf_tst[1] = (UCHAR)rand();
			buf_tst[2] = (UCHAR)rand();
			buf_tst[3] = (UCHAR)rand();
			pBuf[i] = *(PULONG)buf_tst;
		}
	}
	default:
		break;
	}
	QueryPerformanceCounter (&StopPerformCount);
	double msTime = (double)(StopPerformCount.QuadPart - StartPerformCount.QuadPart) / (double)Frequency.QuadPart * 1.E3;
	printf("Writing time is %.2f ms\n", msTime);
}

// 
void CompTestBuffer(PULONG pBuf0, PULONG pBuf1, ULONG sizeBuf, ULONG offset)
{
//	printf("Testing of SDRAM: %0X\r", address);
	ULONG error_num = 0;
	int key_char = 0;
	ULONG cnt = sizeBuf / sizeof(ULONG) + offset;
	for(ULONG i = offset; i < cnt; i++)
	{
		if(!(i % 1000))
			printf("Testing of SDRAM: %08X\r", i);
		ULONG val = pBuf1[i];
		if(pBuf0[i] != val)
		{
			error_num++;
			TCHAR Message[128];
			sprintf_s(Message, "Error to offset: %08X, write: %08X, read: %08X, XOR: %08X\n",
							i, pBuf0[i], pBuf1[i], pBuf0[i] ^ pBuf1[i]);
			printf(Message);
			if(SaveToFile)
			{
				FILE* fstream = NULL;
				fstream = fopen("0.txt", "a+t");
				if(fstream)
				{
					fwrite(Message, sizeof(TCHAR), lstrlen(Message), fstream);
					fclose(fstream);
				}
			}
			else
			{
				printf("Press Esc key for breaking program...\n");
				key_char = _getch();
				if(key_char == 0x1B) //Esc
					break;
				printf("                                        \r");
			}
		}
	}			
	if(!error_num)
		printf("Testing of SDRAM: %08X - OK !!!\n", cnt - 1);
}
